#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <stdio.h>


extern Widget text, filter, fontlist;

void SingleSelectionCB(Widget w, XtPointer client_data, 
		       XtPointer call_data)
{
    XawListReturnStruct *s;
    XFontStruct *font;

    s = (XawListReturnStruct *)call_data;
    font = XLoadQueryFont(XtDisplay(w), s->string);
    if(font) {
	Arg args[2];
	int n = 0;
	XtSetArg(args[n], XtNfont, font); n++;
	XtSetValues(text, args, n);
    }
    else {
	fprintf(stderr, "Unable to load font %s\n", s->string);
    };
}



void ExitCB(Widget widget, XtPointer client_data, 
	    XtPointer call_data)
{
    exit(0);
}


void FilterCB(Widget widget, XtPointer client_data, 
	    XtPointer call_data)
{
    char **fonts;
    int nfonts, i;
    Widget source;
    Arg args[2];
    int n = 0;
    char *p;

    source = XawTextGetSource(filter);
    XtSetArg(args[n], XtNstring, &p); n++;
    XtGetValues(filter, args, n);
    fonts = XListFonts(XtDisplay(widget), p, 10000, &nfonts);
    XawListChange(fontlist, fonts, nfonts, 0, True);
}
