#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <stdio.h>
#include "callbacks.h"
#include "actions.h"

XtActionsRec actionTable[] = {
{"XfbFilter", FilterActionProc},
};



XtAppContext app_context;
Widget shell, text, filter, fontlist, filterCMD;

char *s[] = {"a", "b", "c"};

static void essai(Widget w, XtPointer client, XtPointer call)
{
    printf("essai\n");
}

main(int argc, char **argv)
{
    Arg args[3];
    int n;
    Widget exitCMD;
    Widget viewport1, viewport2, form, paned;
    char **fonts;
    int nfonts, i;
    char *ff;

    if(argc == 1) {
	ff = "*";
    } else {
	ff = argv[1];
    }
    shell = XtAppInitialize(&app_context, "XFontbrowser", NULL, 0, 
			    &argc, argv, NULL, NULL, 0);
    XtAppAddActions(app_context, actionTable, XtNumber(actionTable));

    form = XtVaCreateManagedWidget("form", formWidgetClass, shell, 
				   XtNresizable, True,
				   NULL);
    paned = XtVaCreateManagedWidget("paned", panedWidgetClass, form, 
				    XtNfromVert, NULL,
				    XtNheight, 400,
				    XtNwidth, 600,
				    NULL);
    viewport1 = XtVaCreateManagedWidget("viewport1", viewportWidgetClass, 
					paned,
					XtNallowVert, True,
					XtNuseRight, True,
					XtNallowResize, True,
					NULL);
    viewport2 = XtVaCreateManagedWidget("viewport2", viewportWidgetClass, 
					paned,
					XtNallowVert, True,
					XtNuseRight, True,
					XtNmin, 100,
					XtNallowResize, True,
					NULL);
    
    
    text = XtVaCreateManagedWidget("text", asciiTextWidgetClass, viewport2,
				   XtNeditType, XawtextEdit,
				   XtNallowResize, True,
				   XtNresize, XawtextResizeHeight,
				   NULL);

    exitCMD = XtVaCreateManagedWidget("exitCMD", commandWidgetClass, form,
				    XtNfromVert, paned,
				    XtNfromHoriz, NULL,
				    XtNlabel, "Exit font browser!",
				    NULL);
    XtAddCallback(exitCMD, XtNcallback, 
		  (XtCallbackProc)ExitCB, NULL);
    filter = XtVaCreateManagedWidget("text", asciiTextWidgetClass, form,
				     XtNeditType, XawtextEdit,
				     XtNwidth, 200,
				     XtNfromVert, paned,
				     XtNfromHoriz, exitCMD,
				     XtNstring, ff,
				     NULL);
    filterCMD = XtVaCreateManagedWidget("filterCMD", commandWidgetClass, form,
					XtNfromVert, paned,
					XtNfromHoriz, filter,
					XtNlabel, "Apply filter!",
					NULL);
    XtAddCallback(filterCMD, XtNcallback, 
		  (XtCallbackProc)FilterCB, NULL);

    fontlist = XtVaCreateManagedWidget("fontlist", listWidgetClass, 
				       viewport1, 
				       XtNdefaultColumns, 1,
				       XtNpasteBuffer, True,
				       NULL);
    XtAddCallback(fontlist, XtNcallback, 
		  (XtCallbackProc)SingleSelectionCB, NULL);

    fonts = XListFonts(XtDisplay(shell), ff, 10000, &nfonts);
    XawListChange(fontlist, fonts, nfonts, 0, True);

    XtRealizeWidget(shell);
    XtAppMainLoop(app_context);

}
